<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Generate and Import Coupons for Magento 2
 */

namespace Amasty\Xcoupon\Plugin\SalesRule\Controller\Adminhtml\Promo\Quote;

use Amasty\Xcoupon\Model\Massgenerator;
use Magento\Framework\App\RequestInterface;

class Generate
{
    /**
     * @var Massgenerator
     */
    private $massgenerator;

    /**
     * @var RequestInterface
     */
    private $request;

    public function __construct(
        Massgenerator $massgenerator,
        RequestInterface $request
    ) {
        $this->massgenerator = $massgenerator;
        $this->request = $request;
    }

    public function beforeExecute(\Magento\SalesRule\Controller\Adminhtml\Promo\Quote\Generate $subject)
    {
        $data = $this->request->getParams();

        if ($this->massgenerator->validateGenerateCouponsData($data)) {
            $this->massgenerator->setData($data);
            $clean = $data['amasty_xcoupon_delete_existing_coupons'];
            if ($clean) {
                $this->massgenerator->clean();
            }
        }
    }
}
